+++ sumList Integer : List Integer -> Integer is a function to sum
+++ sum a list of Integers, and so on ...
+++ the first (curried) parameter needs to be of ArithmeticType.
+++ We could probably restrict it to AdditiveType.

sumList (T : ArithmeticType) (list : List T) : T == {
                                            -- T is the type we are summing
    sum : T := 0 ;
    for i in list repeat {
        sum := sum + i ;
    } ;
    sum
} ;


+++ test () should print out testing.
test () : () ==
{
    qq : List Integer -> Integer == sumList Integer ;
    rr : List DoubleFloat -> DoubleFloat == sumList DoubleFloat ;

    import from
        Character,
        List Integer,
        List DoubleFloat,
        Integer,
        DoubleFloat,
        TextWriter,
        String ;

    stdout << "qq" << [1,2,3,4] << " = " << qq [1,2,3,4] << newline
           << "rr" << [1.0,2.0,3.0,4.0] << " = "
           << rr [1.0,2.0,3.0,4.0] << newline ;
}
