#include "aldor"
#include "aldorinterp"

-- A simple example which will find the first occurence of whatever
-- and do the sort for whatever

Simple(S: PrimitiveType): with {
	firstOccurence: (List S, S)	-> MachineInteger;
	sort: (List S, (S,S) -> Boolean) -> List S;
} == add {
	firstOccurence(l: List S, s: S): MachineInteger == {
		(l,n) := find(s, l);
		n;
	}

	--insertion sort
	sort(l:List S, lt:(S,S) -> Boolean):List S == {
		local insrt(x: S, l: List S): List S == {
			empty? l or lt(x, first l) => cons( x, l);
			cons(first l, insrt(x, rest l));
		}
		res: List S := empty;
		for s in l repeat res := insrt( s, res);
		res;
	}
}